/**
 * IBM Confidential
 * OCO Source Materials
 * 5724-M24
 * Copyright IBM Corporation 2008
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
*/
package com.ibm.wbimonitor.sample.fabric.mediation;

public class Constants {
    public static final String COPYRIGHT = "(C) Copyright IBM Corporation 2008.";  //$NON-NLS-1$
    
	// XML element and attribute names in CBE
	public static String WBI_CONTENT_ELEMENT = "wbi:content";  //$NON-NLS-1$

	public static String PAYMENT_ELEMENT = "p:CdtTrfTxInf";  //$NON-NLS-1$

	public static String WBI_NAME_ATTRIBUTE = "wbi:name";  //$NON-NLS-1$

	public static String PAYMENT_STATUS_ELEMENT = "TxInfAndSts";  //$NON-NLS-1$

	// mediate flag name
	public static String MEDIATION_FLAG = "mediated";  //$NON-NLS-1$

	// mediate flag value
	public static String MEDIATION_FLAG_VALUE = "yes";  //$NON-NLS-1$

	// payment bo parent simple path
	public static String PAYMENT_BO_PARENT = "/CommonBaseEvents/CommonBaseEvent/wbi:event/"  //$NON-NLS-1$
			+ "wbi:applicationData/wbi:content/wbi:value/p:PmtInf";  //$NON-NLS-1$

	// payment status bo parent simple path
	public static String PAYMENT_STATUS_BO_PARENT = "/CommonBaseEvents/CommonBaseEvent/wbi:event/wbi:applicationData";  //$NON-NLS-1$

	// Message attributes:
	// ReceiveEXIT/BPELData/wbi:eventNature = 'EXIT'
	// and ReceiveEXIT/BPELData/bpc:bpelId = '3'
	// and ReceiveEXIT/BPELData/bpc:processTemplateName = 'VendorPayment'
	// ReplyEXIT/BPELData/wbi:eventNature = 'EXIT'
	// and ReplyEXIT/BPELData/bpc:bpelId = '4'
	// and ReplyEXIT/BPELData/bpc:processTemplateName = 'VendorPayment'
	// receive exit event bpel id
	public static String RECEIVE_MESSAGE_BPEL_ID = "3";  //$NON-NLS-1$

	// reply exit event bpel id
	public static String REPLY_MESSAGE_BPEL_ID = "4";  //$NON-NLS-1$

	// CBE bpel id simple path
	public static String BPEL_ID_PATH = "/CommonBaseEvents/CommonBaseEvent/wbi:event/wbi:eventPointData/bpc:bpelId";  //$NON-NLS-1$
}
