/**
 * IBM Confidential
 * OCO Source Materials
 * 5724-M24
 * Copyright IBM Corporation 2008
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
*/
package com.ibm.wbimonitor.sample.fabric.mediation;


import java.io.File;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class SimpleDom {
    public static final String COPYRIGHT = "(C) Copyright IBM Corporation 2008.";  //$NON-NLS-1$
    
	public static Element getElementBySimplePath(Document doc, String path) {
		Element tmpElement = null;
		String[] paths = path.split("/");

		for (int i = 1; i < paths.length; i++) {
			if (i == 1) {
				tmpElement = (Element) doc.getElementsByTagName(paths[1])
						.item(0);
				if (tmpElement == null){
					return null;
				}
			} else {
				tmpElement = (Element) tmpElement.getElementsByTagName(paths[i])
						.item(0);
			}
			//System.out.println(tmpElemnt.getNodeName());
		}

		return tmpElement;
	}
	
	public static Element getElementBySimplePath(Element ele, String path) {
		Element tmpElemnt = null;
		String[] paths = path.split("/");

		for (int i = 1; i < paths.length; i++) {
			if (i == 1) {
				tmpElemnt = (Element) ele.getElementsByTagName(paths[1])
						.item(0);
			} else {
				tmpElemnt = (Element) tmpElemnt.getElementsByTagName(paths[i])
						.item(0);
			}
			//System.out.println(tmpElemnt.getNodeName());
		}

		return tmpElemnt;
	}

	public static void setAttributeValue(Element ele, String atrribueName,
			String value) {
		ele.getAttributes().getNamedItem(atrribueName).setNodeValue(value);
	}

	public static void setElementText(Document doc, String simplePath,
			String value) {
		Element ele = getElementBySimplePath(doc, simplePath);
		ele.setTextContent(value);
	}

	public static Document buildDocument(String xmlFilePath) throws Exception {
		DocumentBuilderFactory domFactory = DocumentBuilderFactory
				.newInstance();
		domFactory.setNamespaceAware(true);
		DocumentBuilder builder = domFactory.newDocumentBuilder();
		return builder.parse(xmlFilePath);
	}

	public static Document buildDocument(File xmlFile)throws Exception {
		DocumentBuilderFactory domFactory = DocumentBuilderFactory
				.newInstance();
		domFactory.setNamespaceAware(true);
		DocumentBuilder builder = domFactory.newDocumentBuilder();
		return builder.parse(xmlFile);
	}
	
	public static Element getElementByAttributeValue(Document doc, String path, String attribute, String attrValue){
		Element tmpElemnt = null;
		String[] paths = path.split("/");

		for (int i = 1; i < paths.length - 1; i++) {
			if (i == 1) {
				tmpElemnt = (Element) doc.getElementsByTagName(paths[1])
						.item(0);
			} else {
				tmpElemnt = (Element) tmpElemnt.getElementsByTagName(paths[i])
						.item(0);
			}
			//System.out.println(tmpElemnt.getNodeName());
		}
		NodeList nlist = tmpElemnt.getElementsByTagName(paths[paths.length-1]);
		for (int k = 0; k < nlist.getLength(); k++){
			Node e = nlist.item(k);
			Node n = (e.getAttributes()).getNamedItem(attribute);
			if ( n.getNodeValue().equalsIgnoreCase(attrValue)){
				tmpElemnt = (Element)e;
				break;
			}
		}
		//System.out.println(tmpElemnt.getNodeName() + " " + tmpElemnt.getAttributes().getNamedItem(attribute).getNodeValue());
		return tmpElemnt;
	}
}
