/**
 * IBM Confidential
 * OCO Source Materials
 * 5724-M24
 * Copyright IBM Corporation 2008
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the U.S. Copyright Office.
*/
package com.ibm.wbimonitor.sample.fabric.udf;

import java.lang.reflect.Method;
import java.math.BigDecimal;

import com.ibm.wbimonitor.xml.expression.udf.XPathFunction;

public class CurrencyConvertor
{
    public static final String COPYRIGHT = "(C) Copyright IBM Corporation 2008.";  //$NON-NLS-1$
    
    public CurrencyConvertor()
    {
    }

    public static final String NAMESPACE = "http://currencyconvertor.functions.ibm.com/expression"; //$NON-NLS-1$
    
	/** Get the conversion rate between two currencies */
	public static
	@XPathFunction(
    		namespaceName = NAMESPACE, 
    		localName = "currencyConvertor",  //$NON-NLS-1$
    		description = "Conversion rate between 2 different currencies", //$NON-NLS-1$
    		isDeterministic = true, 
    		isSelfContained = true,
    		callingConvention=XPathFunction.CallingConvention.JAXB
            )
	BigDecimal conversionRate(String fromCurrency, String toCurrency) {
        double rate = 1.0D;
        try{
	        Class c = Class.forName("com.ibm.wbimonitor.sample.fabric.udf.CurrencyConvertor"); //$NON-NLS-1$
	        Method m = c.getDeclaredMethod((new StringBuilder("get_")).append(fromCurrency).toString(), null); //$NON-NLS-1$
	        Double fromCurrencyRate = (Double)m.invoke(null, null); //$NON-NLS-1$
	        m = c.getDeclaredMethod((new StringBuilder("get_")).append(toCurrency).toString(), null);
	        Double toCurrencyRate = (Double)m.invoke(null, null);
	        rate = toCurrencyRate.doubleValue() / fromCurrencyRate.doubleValue();
        } catch (Exception e){
        	//e.printStackTrace();
        	rate = -1D;
        }
        
        return new BigDecimal(rate);
	}

    private static double _USD = 1.0D;
    private static double _CNY = 6.9D;
    private static double _AUD = 1.05D;
    private static double _JPY = 106.9D;
    private static double _EUR = 0.64D;
    public static double get_AUD()
    {
        return _AUD;
    }

    public static double get_CNY()
    {
        return _CNY;
    }

    public static double get_EUR()
    {
        return _EUR;
    }

    public static double get_JPY()
    {
        return _JPY;
    }

    public static double get_USD()
    {
        return _USD;
    }
}
