package com.ibm.wbimonitor.sample.fabric.udf;

import com.ibm.wbimonitor.xml.expression.udf.XPathFunction;

public class DAEventsUDF {
	public static final String COPYRIGHT = "(C) Copyright IBM Corporation 2008."; //$NON-NLS-1$
	
	private static final String NAMESPACE = "http://contextinfoextractor.wbsf.functions.ibm.com/expression";
	
	private static final char PATH_SEPARATOR = '/';

	private static final char PORT_TYPE_SEPARATOR = '#';

	public static @XPathFunction(
			namespaceName = NAMESPACE, 
			localName = "get-service-name", 
			description = "Gets the readable service interface name sans namespace.", 
			isDeterministic = true, 
			isSelfContained = true, 
			callingConvention = XPathFunction.CallingConvention.JAXB)
	String getInternfaceName(String portTypeString) {
		String interfaceName = portTypeString.substring(portTypeString
				.lastIndexOf(PATH_SEPARATOR) + 1, portTypeString
				.lastIndexOf(PORT_TYPE_SEPARATOR));
		
		if(interfaceName.equals("PaymentAmountApprovalService")) {
			return "Payment Approval";
		} else if(interfaceName.equals("CCTIDebulkingService")) {
			return "CCTI Debulking";
		} else if(interfaceName.equals("CCTIValidationService")) {
			return "CCTI Validation";
		} else if(interfaceName.equals("InvolvedPartyManagementRetrieveFullCustomerDetails")) {
			return "Customer Details";
		} else if(interfaceName.equals("OperationalRiskManagementEvaluateCustomerRisk")) {
			return "Risk Evaluation";
		} else if(interfaceName.equals("PayNetSelectionService")) {
			return "Payment Network";
		} else if(interfaceName.equals("PaymentProcessingAcceptOutpaymentInstruction")) {
			return "Payment Processing";
		} else {
		return interfaceName;
		}
	}
	
	public static
	@XPathFunction(
			namespaceName = NAMESPACE,
			localName = "get-porttype-name",
			description = "Gets the readable Port Type Name.",
			isDeterministic = true,
			isSelfContained = true,
			callingConvention = XPathFunction.CallingConvention.JAXB
			)
	String getPortTypeName(String portTypeString) {
		return portTypeString.substring(portTypeString.lastIndexOf(PORT_TYPE_SEPARATOR) + 1);
	}
	
	public static
	@XPathFunction(
			namespaceName = NAMESPACE,
			localName = "get-selected-endpoint",
			description = "Gets the readable Selected Endpoint.",
			isDeterministic = true,
			isSelfContained = true,
			callingConvention = XPathFunction.CallingConvention.JAXB
			)
	String getSelectedEndpointName(String endpointAddress) {
		
		String endpoint = endpointAddress.substring(endpointAddress.lastIndexOf(PATH_SEPARATOR) + 1);
		
		if(endpoint.equals("AutomatedPaymentAmountApprovalServiceExport")) {
			return "Automated";
		} else if(endpoint.equals("ManualPaymentAmountApprovalServiceExport")){
			return "Manual";
		} else if (endpoint.equals("SEPAPaymentNetworkSelectionService")) {
			return "SEPA";
		}else if (endpoint.equals("SWIFTPaymentNetworkSelectionService")) {
			return "SWIFT";
		}else {
			return endpoint;
		}
	}
}
