/***********************************************
 * Licensed Materials - Property of IBM
 * 
 * 5724-R31, 5655-S30
 *
 * (C) Copyright IBM Corp. 2002, 2006 All Rights Reserved.
 * (C) Copyright Webify Solutions, Inc. 2002, 2006 All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 ***********************************************
 */
package com.ibm.websphere.fabric.banking.util;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.logging.Logger;

import com.ibm.websphere.fabric.da.InboundResponse;
import com.ibm.websphere.fabric.da.OutboundResponse;
import com.ibm.websphere.fabric.da.plugin.ResponseListener;
import commonj.sdo.DataObject;
import commonj.sdo.Sequence;

/**
 * This class populates the assertions values required 
 * from the response of Debulk service. 
 * 
 * @author pmangesh
 *
 */
public class CCTIDebulkContextExtractorImpl implements ResponseListener {

    private final Logger logger = Logger
            .getLogger(CCTIDebulkContextExtractorImpl.class.getName());

    /**
     * Default constructor.
     */
    public CCTIDebulkContextExtractorImpl() {
        super();
    }

    /**
     * Getting the state abd country from the response.
     * 
     */
    public OutboundResponse handleResponse(InboundResponse inboundResponse,
            OutboundResponse outboundResponse) {

        ((Sequence) outboundResponse.getOutboundResponseMessage().get(0))
                .setValue(0, ((Sequence) inboundResponse.getResponseMessage()
                        .get(0)).getValue(0));

        DataObject cctiMessage = (DataObject) ((Sequence) outboundResponse
                .getOutboundResponseMessage().get(0)).getValue(0);

        List isoList = cctiMessage.getList("IsoPain");
        int isoSize = isoList.size();
        Map<Object, Object> txnStateCountryMap = new HashMap<Object, Object>();

        for (int i = 0; i < isoSize; i++) {
            logger.info("i = "
                    + i
                    + ":::"
                    + VendorPaymentUtil.getStateCountryBean(
                            (DataObject) isoList.get(i)).toString());

            txnStateCountryMap.put(VendorPaymentUtil
                    .getTransactionId((DataObject) isoList.get(i)),
                    VendorPaymentUtil.getStateCountryBean((DataObject) isoList
                            .get(i)));
        }

        BpelContextHandler.setContextProperties(txnStateCountryMap);

        return outboundResponse;
    }

}