package com.ibm.websphere.fabric.banking.util;

import com.ibm.websphere.fabric.da.PendingRequest;
import com.ibm.websphere.fabric.da.context.Context;
import com.ibm.websphere.fabric.da.plugin.ContextExtractor;
import com.ibm.websphere.fabric.da.plugin.UnexpectedContentException;
import com.ibm.websphere.sca.ServiceManager;
import com.ibm.websphere.fabric.da.types.TypedValue;
import commonj.sdo.DataObject;


public class PaymentAmountApprovalContextExtractor implements ContextExtractor {
	
	private static final String FABRIC_GOVERNANCE = "fc://fabric/governance/fabricproject-inst#71e99f5f-d80c-41a9-8956-365752f58d0d";

	private static final String FABRIC_GOVERNANCE_VALUE = "http://www.webifysolutions.com/2005/10/catalog/governance#FabricProject";

/*	private final Logger logger = Logger
			.getLogger(PaymentNetworkSelectionContextExtractorImpl.class
					.getName());
*/
	/**
	 * Default constructor.
	 */
	public PaymentAmountApprovalContextExtractor() {
		super();
	}

	/**
	 * Return a reference to the component service instance for this implementation
	 * class.  This method should be used when passing this service to a partner reference
	 * or if you want to invoke this component service asynchronously.    
	 *
	 * @generated (com.ibm.wbit.java)
	 */
	@SuppressWarnings("unused")
	private ContextExtractor getMyService() {
		return (ContextExtractor) ServiceManager.INSTANCE.locateService("self");
	}

	/* (non-Javadoc)
	 * @see com.ibm.websphere.fabric.da.plugin.ContextExtractor#extractContext(PendingRequest arg0) 
	 */
	public Context extractContext(PendingRequest arg0)
			throws UnexpectedContentException {
		
		Context context = arg0.getContext();
		DataObject requestDataObject = arg0.getFirstBodyElement();
		
		String amount = requestDataObject.getString("PaymentAmount");
		
		if (amount != null) {
			TypedValue assertionValue = new TypedValue(amount);

			context.setSelectionProperty(
					VendorPaymentUtil.PROP_TRANSACTION_AMOUNT_ASSERTION,
					assertionValue);
		}

		TypedValue governanceFabricProjectValue = new TypedValue(
				FABRIC_GOVERNANCE);

		context.setSelectionProperty(FABRIC_GOVERNANCE_VALUE,
				governanceFabricProjectValue);

		return context;
	}

}